#ifndef id753CAC41D3AE48A1A1D1EC399FD3DADF
#define id753CAC41D3AE48A1A1D1EC399FD3DADF

#include "doorkeeper/primitivetypes.hpp"
#include "doorkeeper/implem/vector.hpp"
#include <cstdint>
#include <cassert>

namespace dk {
	template <uint32_t D>
	class TileCoords {
	public:
		typedef Vector<D> coords;

		TileCoords ( void ) = default;
		TileCoords ( const TileCoords& ) = default;
		explicit TileCoords ( const coords& parSize );
		TileCoords ( const coords& parValue, const coords& parSize );

		TileCoords& operator++ ( void ); //pre
		TileCoords operator++ ( int ); //post
		TileCoords& operator-- ( void ); //pre
		TileCoords operator-- ( int ); //post
		const TileCoords& operator+= ( CoordinateScalarType parValue );
		const TileCoords& operator-= ( CoordinateScalarType parValue );
		bool operator== ( const TileCoords& parOther ) const;
		bool operator!= ( const TileCoords& parOther ) const;
		TileCoords& operator= ( const TileCoords& ) = default;

	private:
		coords m_pos;
		coords m_size;
	};
} //namespace dk

#include "doorkeeper/implem/tilecoords.inl"

#endif
